import '@nativescript/macos-node-api';
import { Event } from '../../dom/dom-utils.js';
import { Text } from '../text/text.js';
export declare class TextChangeEvent extends Event {
    value: string;
    constructor(value: string, eventDict?: EventInit);
}
export declare class NativeTextViewDelegate extends NSObject implements NSTextViewDelegate {
    static ObjCProtocols: (typeof NSTextViewDelegate)[];
    _owner: WeakRef<TextView>;
    static initWithOwner(owner: WeakRef<TextView>): NativeTextViewDelegate;
    controlTextDidChange(_obj: NSNotification): void;
}
export declare class TextView extends Text {
    nativeView?: NSTextView;
    _delegate?: NSTextViewDelegate;
    initNativeView(): NSTextView;
    prepareNativeView(nativeView: NSTextField): void;
    updateTextContent(): void;
    value: string;
    _defaultValueSet: boolean;
    defaultValue: string;
    editable: boolean;
    selectable: boolean;
    richText: boolean;
    focus(): void;
    blur(): void;
    clear(): void;
}
