var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var NativeTextViewDelegate_1;
import '@nativescript/macos-node-api';
import { Event } from '../../dom/dom-utils.js';
import { Layout } from '../../layout/index.js';
import { native } from '../decorators/native.js';
import { view } from '../decorators/view.js';
import { Text } from '../text/text.js';
export class TextChangeEvent extends Event {
    value;
    constructor(value, eventDict) {
        super('textChange', eventDict);
        this.value = value;
        this.value = value;
    }
}
let NativeTextViewDelegate = class NativeTextViewDelegate extends NSObject {
    static { NativeTextViewDelegate_1 = this; }
    static ObjCProtocols = [NSTextViewDelegate];
    static initWithOwner(owner) {
        const delegate = NativeTextViewDelegate_1.new();
        delegate._owner = owner;
        return delegate;
    }
    controlTextDidChange(_obj) {
        const owner = this._owner?.deref();
        if (owner) {
            owner._defaultValueSet = true;
            // @ts-ignore Notification emits as base class of NSTextField so use it's property
            owner.dispatchEvent(new TextChangeEvent(owner.nativeView.stringValue));
            owner.yogaNode.markDirty();
            Layout.computeAndLayout(owner);
        }
    }
};
NativeTextViewDelegate = NativeTextViewDelegate_1 = __decorate([
    NativeClass
], NativeTextViewDelegate);
export { NativeTextViewDelegate };
let TextView = class TextView extends Text {
    _delegate;
    initNativeView() {
        const nativeView = super.initNativeView();
        nativeView.delegate = NativeTextViewDelegate.initWithOwner(new WeakRef(this));
        this._delegate = nativeView.delegate;
        nativeView.string = '';
        nativeView.focusRingType = NSFocusRingType.None;
        nativeView.delegate = this._delegate;
        return nativeView;
    }
    prepareNativeView(nativeView) {
        super.prepareNativeView(nativeView);
        nativeView.isEditable = true;
    }
    updateTextContent() {
        if (this.nativeView) {
            this.nativeView.string = this.textContent || '';
            Layout.computeAndLayout(this);
        }
    }
    _defaultValueSet = false;
    focus() {
        this.nativeView.becomeFirstResponder();
    }
    blur() {
        this.nativeView.resignFirstResponder();
    }
    clear() {
        this.nativeView.string = '';
    }
};
__decorate([
    native({
        setNative: (view, _key, value) => {
            if (view.nativeView) {
                view.nativeView.string = value;
            }
            view._defaultValueSet = true;
        },
        shouldLayout: true,
    }),
    __metadata("design:type", String)
], TextView.prototype, "value", void 0);
__decorate([
    native({
        setNative: (view, _key, value) => {
            if (view._defaultValueSet)
                return;
            if (view.nativeView && !view.nativeView.string) {
                view.nativeView.string = value;
            }
        },
        shouldLayout: true,
    }),
    __metadata("design:type", String)
], TextView.prototype, "defaultValue", void 0);
__decorate([
    native({
        setNative: (view, _key, value) => {
            if (view.nativeView) {
                view.nativeView.isEditable = value;
            }
        },
    }),
    __metadata("design:type", Boolean)
], TextView.prototype, "editable", void 0);
__decorate([
    native({
        setNative: (view, _key, value) => {
            if (view.nativeView) {
                view.nativeView.isSelectable = value;
            }
        },
    }),
    __metadata("design:type", Boolean)
], TextView.prototype, "selectable", void 0);
__decorate([
    native({
        setNative: (view, _key, value) => {
            if (view.nativeView) {
                view.nativeView.isRichText = value;
            }
        },
    }),
    __metadata("design:type", Boolean)
], TextView.prototype, "richText", void 0);
TextView = __decorate([
    view({
        name: 'HTMLTextViewElement',
        tagName: 'text-view',
    })
], TextView);
export { TextView };
//# sourceMappingURL=text-view.js.map